Please ask questions ("how do I...?") on the [forum](https://discuss.pixls.us/c/software/natron), not by filing issues.

Please read carefully the [Troubleshooting](http://natron.readthedocs.io/en/rb-2.3/guide/getstarted-troubleshooting.html) section of the [Natron documentation](http://natron.readthedocs.io) before submitting an issue: this issue may already be signaled, or may have a simple workaround.

Make concrete suggestions for fixing the code ("here is a patch") by filing
a [pull request](https://github.com/MrKepzie/Natron/pull/new/master), not an issue.

Finally, please follow the [Code of Conduct](https://github.com/NatronGitHub/Natron/blob/RB-2.3/CODE_OF_CONDUCT.md) when interacting with the Natron community (both users and developers).


### Problem

Describe the problem or suggestion here.

**Expected behavior:** [What you expected to happen]

**Actual behavior:** [What actually happened]

 * If your problem can be reproduced using a Natron project, please include a link to the project on a file sharing service, or attach the project as a zip file to this issue, if possible.
 
 * If your problem is a crash in an official release/snapshot, please include verbose output from the application
 from a terminal if possible.  If you also submitted a crash report, indicate the CrashID if possible.
 
 * If you need to report a compilation issue, please create a [gist](https://gist.github.com)
 that contains the _full_ verbose build log.
 
 * If your problem is a crash in a build that you made yourself, please create a [gist](https://gist.github.com)
 that contains a _full_ backtrace.


### Steps to Reproduce

1. [First Step]
2. [Second Step]
3. [and so on...]

You may submit a link to any screenshots/videos that can be used to understand how to reproduce the issue.

### Versions

* **Natron version/commit** (they can be retrieved from the About Window): 
* **OS version:** 


